* Auto link only links
* expM1 Memo field
FUNCTION AutoLinkAllLink
PARAMETER tmNotes
LOCAL lmNotes
lmNotes=tmNotes
lmNotes=AutoLinkHttp(lmNotes,'HTTP://')
lmNotes=AutoLinkHttp(lmNotes,'WWW.',1)
lmNotes=AutoLinkHttp(lmNotes,'HTTPS://')
lmNotes=AutoLinkHttp(lmNotes,'FTP://')
lmNotes=AutoLinkHttp(lmNotes,'NEWS://')
lmNotes=AutoLinkHttp(lmNotes,'MMS://')
lmNotes=AutoLinkEmail(lmNotes)
RETURN lmNotes


* Auto link the http references
* expM1 Memo
* expC1 String to search for
* expN1 Pass 1 to add the HTTP
FUNCTION AutoLinkHttp
PARAMETER tmNotes,tcSearchFor,tnAddHttp
LOCAL lmNotes,lnCompteur,lnLocation,lcLink,lcString,lnLocation2,lnCompteur2
LOCAL lcFirst,lcUntilLink,lnCompteur3,lnLenUntilLink,llTag,lnOccur
lmNotes=tmNotes
lnOccurence=OCCUR(tcSearchFor,UPPER(lmNotes))
lnCompteur2=0
FOR lnCompteur=1 TO lnOccurence
   lnCompteur2=lnCompteur2+1
   lnLocation=ATC(tcSearchFor,lmNotes,lnCompteur2)
   lcFirst=SUBSTR(lmNotes,lnLocation-1,1)
   IF INLIST(lcFirst,' ',CHR(13),CHR(10),'(',':','>','"',CHR(9)) OR lnLocation=1
      lcString=SUBSTR(lmNotes,lnLocation)
      lnLocation2=AT(' ',lcString)
      lnLocation3=AT(CHR(13),lcString)
      IF lnLocation3>0
         IF lnLocation2=0 OR lnLocation2>lnLocation3
            lnLocation2=lnLocation3
         ENDIF
      ENDIF
      lnLocation3=AT(CHR(10),lcString)
      IF lnLocation3>0
         IF lnLocation2=0 OR lnLocation2>lnLocation3
            lnLocation2=lnLocation3
         ENDIF
      ENDIF
      lnLocation3=AT('>',lcString)
      IF lnLocation3>0
         IF lnLocation2=0 OR lnLocation2>lnLocation3
            lnLocation2=lnLocation3
         ENDIF
      ENDIF
      lnLocation3=AT('<',lcString)
      IF lnLocation3>0
         IF lnLocation2=0 OR lnLocation2>lnLocation3
            lnLocation2=lnLocation3
         ENDIF
      ENDIF
      lnLocation3=AT('"',lcString)
      IF lnLocation3>0
         IF lnLocation2=0 OR lnLocation2>lnLocation3
            lnLocation2=lnLocation3
         ENDIF
      ENDIF

      * The inclusion of parentheses in URL are now widely used. Many sites also
      * makes us of those and sometimes, we have parentheses inside parentheses.
      * When this is the case, we don't process them. Basically, if someone posts a link
      * without adding any space at the end, such as adding a parenthese right after
      * the link, then we ignore this link.

      lnLocation3=AT(')',lcString)
      IF lnLocation3>0
         IF lnLocation2=0 OR lnLocation2>lnLocation3
            lnLocation2=lnLocation3
         ENDIF

         * If we have a starting parenthese within the string, it's ok
         * Otherwise, it means that the end parenthese represents the beginning of a new string
         IF AT('(',lcString)=0
            IF lnLocation2=0 OR lnLocation2>lnLocation3
               lnLocation2=lnLocation3
            ENDIF
         ENDIF

      ENDIF

      * If the space was not found, then we have to initialize lnLocation2 with the length of the string
      * Otherwise, we will end up by including the dot at the end when it occurs
      IF lnLocation2=0
         lnLocation2=LEN(lcString)+1
      ENDIF

      lcLink=SUBSTR(lcString,1,lnLocation2-1)

      * If last character is a dot
      IF SUBSTR(lcLink,LEN(lcLink))='.'
         lcLink=SUBSTR(lcLink,1,LEN(lcLink)-1)
      ENDIF

      * If last character is a comma
      IF SUBSTR(lcLink,LEN(lcLink))=','
         lcLink=SUBSTR(lcLink,1,LEN(lcLink)-1)
      ENDIF

      * We need to verify that the text is not within a anchor
      IF TextWithinAnchor(lmNotes,lnLocation)
         LOOP
      ENDIF

      * We need to verify that the text is not within a PRE tag
      IF TextWithinPRE(lmNotes,lnLocation)
         LOOP
      ENDIF

      lmNotes=SUBSTR(lmNotes,1,lnLocation-1)+;
       '<A HREF='+IIF(TYPE('tnAddHttp')='N','http://','')+lcLink+' TARGET="_blank">'+lcLink+'</A>'+;
       SUBSTR(lmNotes,lnLocation+LEN(lcLink))

      lnCompteur2=lnCompteur2+1

      * On some particular situations, where an HTTP link contains another HTTP link, such as this one:
      * http://www2.office.daquas.cz/index.htm?http://www2.office.daquas.cz/fo
      * We have to add the number of extra http references to the counter
      * By that, we will make sure to continue with the next HTTP link
      lnOccur=OCCUR(tcSearchFor,UPPER(lcLink))
      IF lnOccur>1
         lnCompteur2=lnCompteur2+lnOccur-1
      ENDIF

   ENDIF
NEXT
RETURN lmNotes


* Auto link the email references
* expM1 Memo
FUNCTION AutoLinkEmail
PARAMETER tmNotes
LOCAL lmNotes,lnCompteur,lnLocation,lcLink,lcString,lnLocation2,lnCompteur2
LOCAL lcFirst,lcUntilLink,lnCompteur3,lnLenUntilLink,llTag
LOCAL lcAfterAt,lcFirstPart,lcFirstPartCorrected,lcLastPart
lmNotes=tmNotes
lnOccurence=OCCUR('@',lmNotes)
lnCompteur2=0
FOR lnCompteur=1 TO lnOccurence
   lnCompteur2=lnCompteur2+1
   lnLocation=ATC('@',lmNotes,lnCompteur2)

   * We need to find the location of the email
   lnLocation2=RAT(' ',LEFT(lmNotes,lnLocation))
   lnLocation2=MAX(lnLocation2,RAT(CHR(13),LEFT(lmNotes,lnLocation)))
   lnLocation2=MAX(lnLocation2,RAT(CHR(10),LEFT(lmNotes,lnLocation)))
   lnLocation2=MAX(lnLocation2,RAT('(',LEFT(lmNotes,lnLocation)))
   lnLocation2=MAX(lnLocation2,RAT(':',LEFT(lmNotes,lnLocation)))
   lnLocation2=MAX(lnLocation2,RAT('>',LEFT(lmNotes,lnLocation)))
   lnLocation2=MAX(lnLocation2,RAT('"',LEFT(lmNotes,lnLocation)))

   * If the location of the email is the character before the @
   IF lnLocation2=lnLocation-1
      LOOP
   ENDIF

   * We need to verify that the text is not within a anchor
   IF TextWithinAnchor(lmNotes,lnLocation)
      LOOP
   ENDIF

   * We need to verify that the text is not within a PRE tag
   IF TextWithinPRE(lmNotes,lnLocation)
      LOOP
   ENDIF

   lcString=SUBSTR(lmNotes,lnLocation)

   * We have to find the position of the last character of the email until we find
   * one that is not in the list of delimiter
   lnLocation3=GetEmailLastCharacter(lcString)

   * If lnLocation3+ is smaller than 3 character, it's not good
   IF lnLocation3<3
      LOOP
   ENDIF

   * Get the email
   lcEmail=SUBSTR(lmNotes,lnLocation2+1,lnLocation3+(lnLocation-lnLocation2-1))

   * String after the @
   lnLocation3=AT('@',lcEmail)
   lcAfterAt=SUBSTR(lcEmail,lnLocation3+1)

   * If there is no dot in the string
   IF AT('.',lcAfterAt)=0
      LOOP
   ENDIF

   * Each character of the first part should be A-Z, a-z, 0-9, '-' (dash), '.'(dot) and '_' (underscore)
   lcFirstPart=UPPER(SUBSTR(lcEmail,1,lnLocation3-1))
   lcFirstPartCorrected=CHRTRAN(lcFirstPart,CHRTRAN(lcFirstPart,'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-._',''),'')
   IF LEN(lcFirstPart)<>LEN(lcFirstPartCorrected)
      LOOP
   ENDIF

   * Each character of the last part should be A-Z, a-z, 0-9, '-' (dash), '.'(dot) and '_' (underscore)
   lcAfterAt=UPPER(lcAfterAt)
   lcFirstPartCorrected=CHRTRAN(lcAfterAt,CHRTRAN(lcAfterAt,'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-._',''),'')
   IF LEN(lcAfterAt)<>LEN(lcFirstPartCorrected)
      LOOP
   ENDIF

   * The last section of the last part can only include between two and four characters
   lcLastPart=SUBSTR(lcAfterAt,RAT('.',lcAfterAt)+1)
   IF LEN(lcLastPart)<2 OR LEN(lcLastPart)>4
      LOOP
   ENDIF

   lmNotes=SUBSTR(lmNotes,1,lnLocation2)+'<A HREF=mailto:'+lcEmail+'>'+lcEmail+'</A>'+;
    SUBSTR(lmNotes,lnLocation2+LEN(lcEmail)+1)

   lnCompteur2=lnCompteur2+1

NEXT
RETURN lmNotes


* Check if a text is within an anchor
* expC1 Text
* expN1 Location
FUNCTION TextWithinAnchor
PARAMETER tcText,tnLocation
LOCAL llTextWithinAnchor,lnLeftTag,lcHtml,lnRightTag,lcTextFromHyperlink
llTextWithinAnchor=.F.

* Grab the text until the beginning of the hyperlink
lcHtml=UPPER(LEFT(tcText,tnLocation))
lnLeftTag=RAT('<',lcHtml)
IF lnLeftTag>0
   lnRightTag=RAT('>',lcHtml)
   IF lnLeftTag>lnRightTag

      * See if we have a right tag after the left tag from the start of the hyperlink
      * This is necessary in case someone has created a left tag, put a hyperlink and never close the tag
      lcTextFromHyperlink=SUBSTR(tcText,tnLocation)
      lnRightTag=AT('>',lcTextFromHyperlink)
      IF lnRightTag>0
         llTextWithinAnchor=.T.
      ENDIF

   ENDIF
ENDIF

* The text should not be within a <A
lnLeftTag=RAT('<A ',lcHtml)
IF lnLeftTag>0
   IF lnLeftTag>RAT('</A>',lcHtml)
      llTextWithinAnchor=.T.
   ENDIF
ENDIF

RETURN llTextWithinAnchor


* Check if a text is within a PRE tag
* expC1 Text
* expN1 Location
FUNCTION TextWithinPRE
PARAMETER tcText,tnLocation
LOCAL llTextWithinAnchor,lnMailTo,lcHtml,lnLocation,lnLocation2
tcText=UPPER(tcText)
llTextWithinAnchor=.F.

* Grab from the first position until the location of the tag
lcHtml=SUBSTR(tcText,1,tnLocation)

* Locate the right most position of a PRE tag
lnLocation=RAT('<PRE',lcHtml)

* If that location is passed the tag
IF lnLocation>tnLocation
   RETURN .F.
ENDIF

* If a /PRE tag is between the right most PRE and the tag
lnLocation2=RAT('</PRE',lcHtml)
IF lnLocation<lnLocation2 AND lnLocation2<tnLocation
   RETURN .F.
ENDIF

* Grab the text after the tag
lcHtml=SUBSTR(tcText,tnLocation)

* Locate the first position of a PRE tag
lnLocation=AT('<PRE',lcHtml)

* Locate the first position of a </PRE> tag
lnLocation2=AT('</PRE',lcHtml)

* If a <PRE> was found before the </PRE> tag
IF lnLocation>0 AND lnLocation<lnLocation2
   RETURN .F.
ENDIF

* If no </PRE> tag was found
IF lnLocation2=0
   RETURN .F.
ENDIF
