*!* Font Styles
#DEFINE FontStyleRegular 0
#DEFINE FontStyleBold 1
#DEFINE FontStyleItalic 2
#DEFINE FontStyleBoldItalic 3
#DEFINE FontStyleUnderline 4
#DEFINE FontStyleStrikeout 8

*!* Units of Measure
#DEFINE UnitWorld 0
#DEFINE UnitDisplay 1
#DEFINE UnitPixel 2
#DEFINE UnitPoint 3
#DEFINE UnitInch 4
#DEFINE UnitDocument 5
#DEFINE UnitMillimeter 6

*!* String Formats
#DEFINE StringFormatFlagsDirectionRightToLeft 1
#DEFINE StringFormatFlagsDirectionVertical 2
#DEFINE StringFormatFlagsNoFitBlackBox 4
#DEFINE StringFormatFlagsDisplayFormatControl 32
#DEFINE StringFormatFlagsNoFontFallback 1024
#DEFINE StringFormatFlagsMeasureTrailingSpaces 2048
#DEFINE StringFormatFlagsNoWrap 4096
#DEFINE StringFormatFlagsLineLimit 8192
#DEFINE StringFormatFlagsNoClip 16384

*!* Text Rendering Hints
#DEFINE TextRenderingHintSystemDefault    0 
#DEFINE TextRenderingHintSingleBitPerPixelGridFit 1
#DEFINE TextRenderingHintAntiAliasGridFit   3 
#DEFINE TextRenderingHintClearTypeGridFit   5

*!* Smoothing Modes
#DEFINE SmoothingModeInvalid  -1 
#DEFINE SmoothingModeDefault  0 
#DEFINE SmoothingModeHighSpeed  1 
#DEFINE SmoothingModeHighQuality 2 
#DEFINE SmoothingModeNone   3 
#DEFINE SmoothingModeAntiAlias  4 

*!* Interpolation Modes
#DEFINE InterpolationModeInvalid    -1 
#DEFINE InterpolationModeDefault    0 
#DEFINE InterpolationModeLowQuality    1 
#DEFINE InterpolationModeHighQuality   2 
#DEFINE InterpolationModeBilinear    3 
#DEFINE InterpolationModeBicubic    4 
#DEFINE InterpolationModeNearestNeighbor  5 
#DEFINE InterpolationModeHighQualityBilinear 6 
#DEFINE InterpolationModeHighQualityBicubic  7 

*!* Wrap Modes
#DEFINE WrapModeTile  0 
#DEFINE WrapModeTileFlipX 1 
#DEFINE WrapModeTileFlipy 2 
#DEFINE WrapModeTileFlipXY 3 
#DEFINE WrapModeClamp  4 

*!* Hatching Styles
#DEFINE HatchStyleHorizontal    0 
#DEFINE HatchStyleVertical     1 
#DEFINE HatchStyleForwardDiagonal   2 
#DEFINE HatchStyleBackwardDiagonal   3 
#DEFINE HatchStyleCross      4 
#DEFINE HatchStyleDiagonalCross    5 
#DEFINE HatchStyle05Percent     6 
#DEFINE HatchStyle10Percent     7 
#DEFINE HatchStyle20Percent     8 
#DEFINE HatchStyle25Percent     9 
#DEFINE HatchStyle30Percent     10 
#DEFINE HatchStyle40Percent     11 
#DEFINE HatchStyle50Percent     12 
#DEFINE HatchStyle60Percent     13 
#DEFINE HatchStyle70Percent     14 
#DEFINE HatchStyle75Percent     15 
#DEFINE HatchStyle80Percent     16 
#DEFINE HatchStyle90Percent     17 
#DEFINE HatchStyleLightDownwardDiagonal  18 
#DEFINE HatchStyleLightUpwardDiagonal  19 
#DEFINE HatchStyleDarkDownwardDiagonal  20 
#DEFINE HatchStyleDarkUpwardDiagonal  21 
#DEFINE HatchStyleWideDownwardDiagonal  22 
#DEFINE HatchStyleWideUpwardDiagonal  23 
#DEFINE HatchStyleLightVertical    24 
#DEFINE HatchStyleLightHorizontal   25 
#DEFINE HatchStyleNarrowVertical   26 
#DEFINE HatchStyleNarrowHorizontal   27 
#DEFINE HatchStyleDarkVertical    28 
#DEFINE HatchStyleDarkHorizontal   29 
#DEFINE HatchStyleDashedDownwardDiagonal 30 
#DEFINE HatchStyleDashedUpwardDiagonal  31 
#DEFINE HatchStyleDashedHorizontal   32 
#DEFINE HatchStyleDashedVertical   33 
#DEFINE HatchStyleSmallConfetti    34 
#DEFINE HatchStyleLargeConfetti    35 
#DEFINE HatchStyleZigZag     36 
#DEFINE HatchStyleWave      37 
#DEFINE HatchStyleDiagonalBrick    38 
#DEFINE HatchStyleHorizontalBrick   39 
#DEFINE HatchStyleWeave      40 
#DEFINE HatchStylePlaid      41 
#DEFINE HatchStyleDivot      42 
#DEFINE HatchStyleDottedGrid    43 
#DEFINE HatchStyleDottedDiamond    44 
#DEFINE HatchStyleShingle     45 
#DEFINE HatchStyleTrellis     46 
#DEFINE HatchStyleSphere     47 
#DEFINE HatchStyleSmallGrid     48 
#DEFINE HatchStyleSmallCheckerBoard   49 
#DEFINE HatchStyleLargeCheckerBoard   50 
#DEFINE HatchStyleOutlinedDiamond   51 
#DEFINE HatchStyleSolidDiamond    52 